Assets = 
{
	Asset("SOUND", "sound/toadstool.fsb"),
	Asset("SOUNDPACKAGE", "sound/toadstool.fev"),
	Asset("IMAGE", "minimap/toadstool_cap.tex"),
	Asset("ATLAS", "minimap/toadstool_cap.xml"),
	Asset("IMAGE", "minimap/toadstool.tex"),
	Asset("ATLAS", "minimap/toadstool.xml"),
	Asset("IMAGE", "images/inventoryimages/shroom_skin.tex"),
	Asset("ATLAS", "images/inventoryimages/shroom_skin.xml"),
}

PrefabFiles = 
{
	"toadstool",
	"toadstool_cap",
	"toadstool_mushroomsprout",
	"toadstool_shroom_skin",
	"toadstool_mushroombomb",
}

require = GLOBAL.require
local TUNING = GLOBAL.TUNING
local GetPlayer = GLOBAL.GetPlayer
local Combat = require "components/combat"
local follower = require "components/follower"
local harvestable = require "components/harvestable"
local ccanattack = Combat.CanAttack
local GetPlayer = GLOBAL.GetPlayer
local STRINGS = GLOBAL.STRINGS
local RECIPETABS = GLOBAL.RECIPETABS
local Recipe = GLOBAL.Recipe
local Ingredient = GLOBAL.Ingredient
local TECH = GLOBAL.TECH
local ACTIONS = GLOBAL.ACTIONS
local Vector3 = GLOBAL.Vector3
local distsq = GLOBAL.distsq
local GetWorld = GLOBAL.GetWorld
local Prefabs = GLOBAL.Prefabs
local Transform = GLOBAL.Transform
local Physics = GLOBAL.Physics
local AnimState = GLOBAL.AnimState
local FRAMES = GLOBAL.FRAMES
local DEGREES = GLOBAL.DEGREES
local SpawnPrefab = GLOBAL.SpawnPrefab
local TheCamera = GLOBAL.TheCamera
local seg_time = 30
local day_segs = 10
local dusk_segs = 4
local night_segs = 2
local day_time = seg_time * day_segs
local dusk_time = seg_time * dusk_segs
local night_time = seg_time * night_segs
local total_day_time = seg_time*16
local TheSim = GLOBAL.TheSim
local SpawnPrefab = GLOBAL.SpawnPrefab
local GetSeasonManager = GLOBAL.GetSeasonManager
local SEASONS = GLOBAL.SEASONS
local GetClock = GLOBAL.GetClock
local GetWorld = GLOBAL.GetWorld

AddMinimapAtlas("minimap/toadstool_cap.xml")
AddMinimapAtlas("minimap/toadstool.xml")

GLOBAL.TUNING.TOADSTOOL_SPAWN_DELAY = GetModConfigData("toadstool_spawn_delay") * 35 * total_day_time
GLOBAL.TUNING.TOADSTOOL_ORNATECHEST = GetModConfigData("toadstool_good_drop")

function ROGComponents(inst)
	if not inst.components.frogboss then
		inst:AddComponent("frogboss")
	end
end

function SWComponents(inst)
	if not inst.components.frogbosssw then
		inst:AddComponent("frogbosssw")
	end
end

if GLOBAL.IsDLCInstalled(GLOBAL.CAPY_DLC) and GLOBAL.IsDLCEnabled(GLOBAL.CAPY_DLC) then
	AddPrefabPostInit("shipwrecked",SWComponents)
else
	AddPrefabPostInit("forest",ROGComponents)
end